#ifndef DEF_COMMON_H
#define DEF_COMMON_H

// subdevice / telegrambufferprocessing code - compiler switches:
// ==============================================================
// 
// compiler switch label / meaning (if #defined)       
// 
// HFSM_INACTIVE           help signal decoding disabled
// BIN_SIAS_ACTIVE         binary safety actor slave
// TEST_ACTIVE             use extra code for testing the FSM (finite statemachine)


// ************************************************* 
// *** THIS IS THE ONLY PLACE FOR DEFINITIONS OF *** 
// ***                                           *** 
// *** - target processor        :   PROC_xxxx   *** 
// *** - target compiler         :   COMP_xxxx   *** 
// *************************************************

// Type of CPU?
// ------------
   
#define PROC_AVR

// Type of Compiler?
// --------------------------
#define COMP_GCC







// ------------------------- register definitions --------------------------
#ifdef PROC_AVR
  #include <avr/io.h>
  #include <avr/interrupt.h>
#endif

#include "deftypes.h"


#endif  // DEF_COMMON_H
