#ifndef DEF_DEFTYPES_H
#define DEF_DEFTYPES_H

#define _C99INTTYPES


#if !defined(_C99INTTYPES)
  #error "no int type defines for this processor!"
#else // C99 inttypes in use ...

 #include <Inttypes.h> // defines the following types:
 
// -------------------------------------------------------------------------------------- 
// C99 specifier  common equivalent   signing   bits   bytes   min to max value
// -------------------------------------------------------------------------------------- 
// 
//  int8_t               signed char  signed     8     1         -128 to +127        
// uint8_t             unsigned char  unsigned   8     1            0 to  255  
//  int16_t                    short  signed    16     2       -32768 to +32767      
// uint16_t           unsigned short  unsigned  16     2            0 to  65535      
//  int32_t                     long  signed    32     4  -2147483648 to  2147483647 
// unit32_t            unsigned long  unsigned  32     4            0 to  4294967295 
//  int64_t                long long  signed    64     8  -2^64/2 to 9223372036854775807
// unit64_t       unsigned long long  unsigned  64     8  0 to 18446744073709551615  

typedef char      char_t;          // no sign    8     1  character types                        
 #include <stdbool.h>
typedef bool      bool_t;          // no sign    8     1  0 to  1       

typedef unsigned  bitfield_t;      //   >=8     >= 1   

// constants (defined by <stdbool.h>)
// 0 = false, 
// 1 = true   
#endif

// constants 
#define OFF          (          0)
#define ON           (          1)

#define NUL          ( (void *)0 )

#endif  // DEF_DEFTYPES_H 
