#include <avr/io.h>
#include <avr/interrupt.h> 	//header-file for global interrupt activation
#include <float.h>
#include <stdio.h>

#include "serial.h"
#include "user_interface.h"
#include "timer.h"
#include "sht11.h"


typedef union
{ 
	unsigned int i;
	float f;
} value_t;


//VARIABLEN
unsigned char prescaler10ms;
bool b_tick10ms;				// flag for 10ms tick
//unsigned char anzeige=0;		//flag to switch display;
//variablen fr ####mpx4115A####
//char 	result_LCD[5];
//char 	voltage_LCD[5];
//char 	druck_LCD[4];
int 	ii;
float 	result;
float 	voltage;
//float 	druck;
//float	druck_alt;
//float	druck_neu;
float	fhumi_val;
float	ftemp_val;
int		ihumi_val;
int		itemp_val;
unsigned char humi[2];
unsigned char temp[2];

int  main(void);
void init(void);
char in(void);
int  out(char var);
void nl(void);

//----------------------------------------------------------------------------
//
int main(void)
{

  USART_vInit(0, 19200); // 38400);
//  print_str("\n\n\nSht11 Testprojekt\n\r");
                  //initialize system
  fdevopen(out, NULL); //important if using stdio.h functions
  printf("%u",123);    // prints:   123456

  sei();
  InitTimer0();
  //lcd_init();
  prescaler10ms = PRESCALER_TICK_10MS;

  // init DATA and SCK port pin directions
  DDRA |=  (1<<DDA2);  // DATA output 
  DDRA |=  (1<<DDA3);  // SCK  output

  while(1)
  {
	//ButtonControl();

	value_t humi_val,temp_val;
	float dew_point;
	unsigned char error,checksum;
	unsigned long int inx;
	s_connectionreset();
	if(b_tick10ms)
	{ 	
	  error=0;
//    error+=s_measure((unsigned char*) &ihumi_val,&checksum,HUMI); //measure humidity
//	  error+=s_measure((unsigned char*) &itemp_val,&checksum,TEMP); //measure temperature

      error+=s_measure(humi,&checksum,HUMI); //measure humidity
	  error+=s_measure(temp,&checksum,TEMP); //measure temperature
	  if(error!=0) 
	    s_connectionreset(); //in case of an error: connection reset
	  else			
	  { 
	    fhumi_val=(float)(humi[0] <<8 | humi[1]); //converts integer to float
		ftemp_val=(float)(temp[0] <<8 | temp[1]); //converts integer to float
		calc_sth11(&fhumi_val,&ftemp_val); //calculate humidity, temperature
		dew_point=calc_dewpoint(humi_val.f,temp_val.f); //calculate dew point
		//send final data to serial interface (UART)
		printf("\n\r\n\rtemp:%5.1fC humi:%5.1f%% dew point:%5.1fC\n",ftemp_val,fhumi_val,dew_point);
		//lcd_write();
	  }

	  //Spannung_einlesen();
	  //Umrechnung_Volt();
	  //Umrechnung_mbar();
	  //lcd_writer();
	  b_tick10ms=false;
			
	  //----------wait approx. 0.8s to avoid heating up SHTxx------------------------------
	  for (inx=0;inx<400000;inx++)
	  {
	    NOP; NOP; NOP; NOP;
	    NOP; NOP; NOP; NOP;
	    NOP; NOP; NOP; NOP;
        NOP; NOP; NOP; NOP;
		NOP; NOP; NOP; NOP;
		NOP; NOP; NOP; NOP;
		NOP; NOP; NOP; NOP;
		NOP; NOP; NOP; NOP;
		NOP; NOP; NOP; NOP;
		NOP; NOP; NOP; NOP;
		NOP; NOP; NOP; NOP;
	  }
	}
  }
  return(0);
}









/*

// ***************** INCLUDES ***********************
#include <avr/io.h>
#include <stdio.h>
// ***************** PROTOTYPES *********************
int  main(void);
void init(void);
char in(void);
int  out(char var);
void nl(void);
// ***************** FUNCTIONS **********************
int main(void)
{
    init();                    //initialize system
    fdevopen(out,0,0); //important if using stdio.h functions
    while(1)                //infinite loop (foreground thread)
    {
        printf("%u",123);    // prints:   123456
        putchar(0x34);
        putchar(0x35);
        putchar(0x36);
        nl();           // outputs new line
    }
    return 0;
}
*/



//**************************************************
// out is also used by standard
// output devices (printf,putchar)
//**************************************************
int out(char var)
{
  while((UCSR0A&(1<<UDRE0)) == 0)
    ;
  // Transmit data
  UDR0 = var;
    return 0;
}
//**************************************************
char in(void)
{
  while((UCSR0A&(1<<RXC0)) == 0) 
    ;

  // Return received data
  return UDR0;
}
//**************************************************
void nl(void)
{
    out(0x0A);
    out(0x0D);
}
//************************************************** 

// eof

